searchData={"items":[{"type":"task","title":"mix nerves.loaddefconfig","doc":"Load the nerves_defconfig configuration into the Nerves artifact.\nThis is the opposite of `make savedefconfig`.","ref":"Mix.Tasks.Nerves.Loaddefconfig.html"},{"type":"task","title":"Usage - mix nerves.loaddefconfig","doc":"mix nerves.loaddefconfig","ref":"Mix.Tasks.Nerves.Loaddefconfig.html#module-usage"},{"type":"extras","title":"ATSAMA5D27-WLSOM1 Evaluation Kit","doc":"# ATSAMA5D27-WLSOM1 Evaluation Kit\n\nhttps://www.microchip.com/DevelopmentTools/ProductDetails/PartNO/DM320117\n\n![ATSAMA5D27-WLSOM1 Evaluation Kit image](assets/images/ATSAMA5D27-WLSOM1.jpg)\n  [Image credit](https://www.microchip.com/_ImagedCopy/191126-MPU-PHOTO-ATSAMA5D27-WLSOM1-EK1%20Evaluation%20Kit-Angle-5x7.jpg) \n\n| Feature              | Description                     |\n| -------------------- | ------------------------------- |\n| CPU                  | 500 MHz ARM Cortex-A5           |\n| Memory               | 256M DDR2                       |\n| Storage              | MicroSD                         |\n| GPIO, I2C, SPI       | Yes - [Elixir Circuits](https://github.com/elixir-circuits) |\n| UART                 | ttyS0                           |\n| Ethernet             | Yes                             |\n| Video                | Yes                             |\n| Camera Interface     | Yes - Parallel ISC              |\n\n#","ref":"readme.html"},{"type":"extras","title":"Docs - ATSAMA5D27-WLSOM1 Evaluation Kit","doc":"- [ATSAMA5D27-WLSOM1-EK1 dev kit user guide](https://ww1.microchip.com/downloads/en/DeviceDoc/SAMA5D2-Wireless-SOM1-Kit-User's-Guide-50002931d.pdf)\n- [ATSAMA5D27-WLSOM1 datasheet](http://ww1.microchip.com/downloads/en/DeviceDoc/ATSAMA5D27-WLSOM1-Datasheet-60001590b.pdf)\n- [SAMA5D2 series datasheet](https://ww1.microchip.com/downloads/en/DeviceDoc/DS60001476B.pdf)\n\n# Using\n\nThe most common way of using this Nerves System is create a project with `mix\nnerves.new` and to export `MIX_TARGET=sama5d27_wlsom1_ek`. See the [Getting started\nguide](https://hexdocs.pm/nerves/getting-started.html#creating-a-new-nerves-app)\nfor more information.\n\nIf you need custom modifications to this system for your device, clone this\nrepository and update as described in [Making custom\nsystems](https://hexdocs.pm/nerves/systems.html#customizing-your-own-nerves-system)\n\n# GPIO\n\nThe WLSOM1 exposes four banks of GPIO: `A`, `B`, `C`, `D`. The physical GPIO\npins are numbered logically in sequence from `PA0` (`gpio0`) to\n`PD31` (`gpio127`) when exposed via sysfs or [`Circuits.GPIO`](https://hex.pm/packages/circuits_gpio).\n\n|  Pin  |  GPIO  |   |  Pin  |  GPIO  |   |  Pin  |  GPIO  |   |  Pin  |  GPIO  |\n|  ---  |  ----  | - |  ---  |  ----  | - |  ---  |  ----  | - |  ---  |  ----  |\n|  PA0  |  0  | |  PB0  |  32  | |  PC0  |  64  | |  PD0  |  96  |\n|  PA1  |  1  | |  PB1  |  33  | |  PC1  |  65  | |  PD1  |  97  |\n|  PA2  |  2  | |  PB2  |  34  | |  PC2  |  66  | |  PD2  |  98  |\n|  PA3  |  3  | |  PB3  |  35  | |  PC3  |  67  | |  PD3  |  99  |\n|  PA4  |  4  | |  PB4  |  36  | |  PC4  |  68  | |  PD4  |  100  |\n|  PA5  |  5  | |  PB5  |  37  | |  PC5  |  69  | |  PD5  |  101  |\n|  PA6  |  6  | |  PB6  |  38  | |  PC6  |  70  | |  PD6  |  102  |\n|  PA7  |  7  | |  PB7  |  39  | |  PC7  |  71  | |  PD7  |  103  |\n|  PA8  |  8  | |  PB8  |  40  | |  PC8  |  72  | |  PD8  |  104  |\n|  PA9  |  9  | |  PB9  |  41  | |  PC9  |  73  | |  PD9  |  105  |\n|  PA10  |  10  | |  PB10  |  42  | |  PC10  |  74  | |  PD10  |  106  |\n|  PA11  |  11  | |  PB11  |  43  | |  PC11  |  75  | |  PD11  |  107  |\n|  PA12  |  12  | |  PB12  |  44  | |  PC12  |  76  | |  PD12  |  108  |\n|  PA13  |  13  | |  PB13  |  45  | |  PC13  |  77  | |  PD13  |  109  |\n|  PA14  |  14  | |  PB14  |  46  | |  PC14  |  78  | |  PD14  |  110  |\n|  PA15  |  15  | |  PB15  |  47  | |  PC15  |  79  | |  PD15  |  111  |\n|  PA16  |  16  | |  PB16  |  48  | |  PC16  |  80  | |  PD16  |  112  |\n|  PA17  |  17  | |  PB17  |  49  | |  PC17  |  81  | |  PD17  |  113  |\n|  PA18  |  18  | |  PB18  |  50  | |  PC18  |  82  | |  PD18  |  114  |\n|  PA19  |  19  | |  PB19  |  51  | |  PC19  |  83  | |  PD19  |  115  |\n|  PA20  |  20  | |  PB20  |  52  | |  PC20  |  84  | |  PD20  |  116  |\n|  PA21  |  21  | |  PB21  |  53  | |  PC21  |  85  | |  PD21  |  117  |\n|  PA22  |  22  | |  PB22  |  54  | |  PC22  |  86  | |  PD22  |  118  |\n|  PA23  |  23  | |  PB23  |  55  | |  PC23  |  87  | |  PD23  |  119  |\n|  PA24  |  24  | |  PB24  |  56  | |  PC24  |  88  | |  PD24  |  120  |\n|  PA25  |  25  | |  PB25  |  57  | |  PC25  |  89  | |  PD25  |  121  |\n|  PA26  |  26  | |  PB26  |  58  | |  PC26  |  90  | |  PD26  |  122  |\n|  PA27  |  27  | |  PB27  |  59  | |  PC27  |  91  | |  PD27  |  123  |\n|  PA28  |  28  | |  PB28  |  60  | |  PC28  |  92  | |  PD28  |  124  |\n|  PA29  |  29  | |  PB29  |  61  | |  PC29  |  93  | |  PD29  |  125  |\n|  PA30  |  30  | |  PB30  |  62  | |  PC30  |  94  | |  PD30  |  126  |\n|  PA31  |  31  | |  PB31  |  63  | |  PC31  |  95  | |  PD31  |  127  |\n\n# UART\n\n|  Header  |  Device  |\n|  ------  |  ------  |\n|  mikro BUS 1  |  `ttyS3`  |\n|  mikro BUS 2  |  `ttyS2`  |\n\n# Wi-Fi\n\nThe WLSOM1 contains a ATWILC3000 Wi-Fi / Bluetooth module. Wi-Fi can be enabled\nby loading the kernel module.\n\n```elixir\niex> cmd \"modprobe wilc-sdio\"\n```\n\nIf the Wi-Fi module is set to access point (AP) mode, it will need to be reset\nif its VintageNet configuration is updated at runtime.\n\n```elixir\ncmd \"rmmod wilc-sdio\"\ncmd \"modprobe wilc-sdio\"\n```\n\n*The Wi-Fi module supports 8 connected devices in access point (AP) mode.*\n\n# Bluetooth\n\nThe ATWILC3000 includes Bluetooth Low Energy capabilities that can be utilized\nafter following a specific configuration and startup sequence. In general, there\nare two routes that can be taken to make use of Bluetooth in Nerves: [BlueZ](http://www.bluez.org/)\nand [BlueHeron](https://github.com/blue-heron/blue_heron). So far, only BlueZ\nhas been tested on the WLSOM1.","ref":"readme.html#docs"},{"type":"extras","title":"BlueZ - ATSAMA5D27-WLSOM1 Evaluation Kit","doc":"In order to use the BlueZ stack, there are a number of config options and\npackages that are required.\n\nAdd these config options to the Linux defconfig:\n```\nCONFIG_BT_HCIUART=m\nCONFIG_BT_HCIUART_H4=y\n```\n\nAdd these packages to `nerves_defconfig`:\n```\nBR2_PACKAGE_BLUEZ5_UTILS=y\nBR2_PACKAGE_BLUEZ5_UTILS_CLIENT=y\nBR2_PACKAGE_BLUEZ5_UTILS_TOOLS=y\nBR2_PACKAGE_BLUEZ5_UTILS_DEPRECATED=y\n```\n\n**Note:** The Bluetooth power up sequence requires _both_ `dbus-daemon`\nand `bluetoothd`. It is recommended to use either [MuonTrap](https://github.com/fhunleth/muontrap)\nor [Ports](https://hexdocs.pm/elixir/main/Port.html) for running them as\nbackground processes.\n\nHere is an example that uses Ports for the startup sequence:\n\n```elixir\nSystem.cmd(\"modprobe\", [\"wilc-sdio\"])\nProcess.sleep(5000)\n\nFile.write(\"/dev/wilc_bt\", \"BT_POWER_UP\")\nProcess.sleep(1000)\n\nFile.write(\"/dev/wilc_bt\", \"BT_DOWNLOAD_FW\")\nProcess.sleep(100)\n\nFile.rm_rf(\"/run/messagebus.pid\")\nFile.mkdir_p(\"/run/dbus\")\n\nPort.open(\n  {:spawn_executable, \"/usr/bin/dbus-daemon\"},\n  [:binary, :exit_status, :stderr_to_stdout,\n    args: [\"--system\", \"--nofork\"]]\n)\n\nSystem.cmd(\"hciattach\", [\"/dev/ttyS1\", \"any\", \"115200\", \"noflow\", \"nosleep\"])\nProcess.sleep(300)\n\nSystem.cmd(\"hciconfig\", [\"hci0\", \"up\"])\n\nFile.mkdir_p(\"/data/bluetooth\")\n\nPort.open(\n  {:spawn_executable, \"/usr/libexec/bluetooth/bluetoothd\"},\n  [:binary, :exit_status, :stderr_to_stdout,\n    args: [\"-p\", \"time\", \"-n\", \"-C\", \"--localstatedir=/data\"]]\n)\n```\n\n`bluetoothctl` can be used to run various Bluetooth Low Energy operations.\nHere is an example of how to open a port for running `bluetoothctl`:\n\n```elixir\nbluetoothctl = Port.open(\n  {:spawn_executable, \"/usr/bin/bluetoothctl\"},\n  [:binary, :exit_status, :stderr_to_stdout]\n)\n```\n\n# Ethernet\n\nA unique hardware address for the eth0 interface is programmed into the QSPI\nflash memory from the factory and is read set by U-Boot. Inorder to read from\nthe flash memory, you will need to ensure the QSPI flash is being powered by\nremoving the shunt from jumper J8 labeled \"Disable Boot\".\n\nThe hardware address of the interface can also be forced by setting the U-Boot\nenvironment variable `ethaddr`. If neither of these locations are accessible,\nLinux will assign a random hardware address to the interface on every boot.\n\n# Supported USB Wi-Fi Devices\n\nThe base image includes drivers and firmware for Ralink RT53xx (rt2800usb\ndriver) and RealTek RTL8712U (r8712u driver) devices.\n\nWe are still working out which subset of all possible Wi-Fi dongles to support\nin our images. At some point, we may have the option to support all dongles and\nselectively install modules at packaging time, but until then, these drivers and\ntheir associated firmware blobs add significantly to Nerves release images.\n\nIf you are unsure what driver your Wi-Fi dongle requires, run Debian and\nconfigure Wi-Fi for your device. At a shell prompt, run lsmod to see which\ndrivers are loaded. Running dmesg may also give a clue. When using dmesg,\nreinsert the USB dongle to generate new log messages if you don't see them.","ref":"readme.html#bluez"},{"type":"extras","title":"Provisioning devices - ATSAMA5D27-WLSOM1 Evaluation Kit","doc":"This system supports storing provisioning information in a small key-value store\noutside of any filesystem. Provisioning is an optional step and reasonable\ndefaults are provided if this is missing.\n\nProvisioning information can be queried using the Nerves.Runtime KV store's\n[`Nerves.Runtime.KV.get/1`](https://hexdocs.pm/nerves_runtime/Nerves.Runtime.KV.html#get/1)\nfunction.\n\nKeys used by this system are:\n\nKey                    | Example Value     | Description\n:--------------------- | :---------------- | :----------\n`nerves_serial_number` | `\"12345678\"`      | By default, this string is used to create unique hostnames and Erlang node names.\n\nThe normal procedure would be to set these keys once in manufacturing or before\ndeployment and then leave them alone.\n\nFor example, to provision a serial number on a running device, run the following\nand reboot:\n\n```elixir\niex> cmd(\"fw_setenv nerves_serial_number 12345678\")\n```\n\nThis system supports setting the serial number offline. To do this, set the\n`NERVES_SERIAL_NUMBER` environment variable when burning the firmware. If you're\nprogramming MicroSD cards using `fwup`, the commandline is:\n\n```sh\nsudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw\n```\n\nSerial numbers are stored on the MicroSD card so if the MicroSD card is\nreplaced, the serial number will need to be reprogrammed. The numbers are stored\nin a U-boot environment block. This is a special region that is separate from\nthe application partition so reformatting the application partition will not\nlose the serial number or any other data stored in this block.\n\nAdditional key value pairs can be provisioned by overriding the default provisioning.conf\nfile location by setting the environment variable\n`NERVES_PROVISIONING=/path/to/provisioning.conf`. The default provisioning.conf\nwill set the `nerves_serial_number`, if you override the location to this file,\nyou will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices"},{"type":"extras","title":"Hostname - ATSAMA5D27-WLSOM1 Evaluation Kit","doc":"By default the hostname will only include the last 4 digits of the board\nidentifier. If you would rather use the entire identifier, set the following\nin your `config/target.exs` file:\n\n```elixir\nconfig :nerves,\n  erlinit: [\n    uniqueid_exec: \"boardid\"\n  ]\n```","ref":"readme.html#hostname"}],"content_type":"text/markdown"}